"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var _extends = _interopDefault(require("@babel/runtime/helpers/extends")), _defineProperty = _interopDefault(require("@babel/runtime/helpers/defineProperty")), _objectWithoutProperties = _interopDefault(require("@babel/runtime/helpers/objectWithoutProperties")), core = require("@westpac/core"), react = require("react"), PropTypes = _interopDefault(require("prop-types")), Wrapper = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("div", rest);
}, wrapperStyles = function() {
  var COLORS = core.useBrand().COLORS;
  return {
    "@media screen and (max-width: 480px)": {
      width: "100%",
      marginBottom: "1.125rem",
      overflowY: "hidden",
      overflowX: "auto",
      border: "1px solid ".concat(COLORS.border)
    }
  };
}, wrapperAttributes = function() {
  return null;
}, defaultWrapper = {
  component: Wrapper,
  styles: wrapperStyles,
  attributes: wrapperAttributes
}, Table = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("table", rest);
}, tableStyles = function(_, _ref2) {
  var striped = _ref2.striped, COLORS = core.useBrand().COLORS;
  return {
    width: "100%",
    maxWidth: "100%",
    marginBottom: "1.3125rem",
    backgroundColor: "#fff",
    borderCollapse: "collapse",
    "tbody > tr:nth-of-type(even)": {
      backgroundColor: striped && COLORS.light
    },
    "tbody + tbody": {
      borderTop: "2px solid ".concat(COLORS.hero)
    }
  };
}, tableAttributes = function() {
  return null;
}, defaultTable = {
  component: Table,
  styles: tableStyles,
  attributes: tableAttributes
}, pkg = {
  name: "@westpac/table",
  version: "1.0.0-beta.2",
  description: "Table component for the Westpac GEL",
  repository: "https://github.com/WestpacGEL/GEL/tree/master/components/table",
  author: "Westpac GEL Team <gel@westpac.com.au>",
  contributors: [ {
    name: "Dominik Wilkowski",
    email: "Hi@Dominik-Wilkowski.com",
    url: "https://dominik-wilkowski.com"
  }, {
    name: "Jonathan Stening",
    email: "info@jonathanstening.com",
    url: "http://jonathanstening.com"
  } ],
  license: "GPL-3.0+",
  scripts: {
    start: "PACKAGE_NAME=table webpack-dev-server --config ../../helpers/example/start.webpack.config.js",
    test: "exit 0 # start-server-and-test start http://localhost:8080 test:all",
    "test:dev": "start-server-and-test start http://localhost:8080 test:test-dev",
    "test:all": "yarn test:integration",
    "test:integration": "cypress run",
    "test:test-dev": "cypress open"
  },
  main: "dist/table.cjs.js",
  module: "dist/table.esm.js",
  dependencies: {
    "@babel/runtime": "^7.9.6",
    "@westpac/core": "^1.0.1",
    "prop-types": "^15.7.2"
  },
  peerDependencies: {
    react: "^16.13.1"
  },
  devDependencies: {
    cypress: "^4.5.0",
    react: "^16.13.1",
    "start-server-and-test": "^1.11.0"
  }
};

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var TableContext = react.createContext(), useTableContext = function() {
  var context = react.useContext(TableContext);
  if (!context) throw new Error("Table sub-components should be wrapped in a <Table>.");
  return context;
}, Table$1 = function(_ref) {
  var striped = _ref.striped, bordered = _ref.bordered, children = _ref.children, componentOverrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "striped", "bordered", "children", "overrides" ]), context = react.useContext(TableContext);
  bordered = context && context.bordered || bordered;
  var _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], defaultOverrides = {
    Wrapper: defaultWrapper,
    Table: defaultTable
  }, state = _objectSpread({
    striped: striped,
    bordered: bordered,
    overrides: componentOverrides
  }, rest), _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides), _overrideReconciler$W = _overrideReconciler.Wrapper, Wrapper = _overrideReconciler$W.component, wrapperStyles = _overrideReconciler$W.styles, wrapperAttributes = _overrideReconciler$W.attributes, _overrideReconciler$T = _overrideReconciler.Table, Table = _overrideReconciler$T.component, tableStyles = _overrideReconciler$T.styles, tableAttributes = _overrideReconciler$T.attributes;
  return core.jsx(TableContext.Provider, {
    value: {
      striped: striped,
      bordered: bordered,
      state: state
    }
  }, core.jsx(Wrapper, _extends({
    state: state
  }, wrapperAttributes(state), {
    css: wrapperStyles(state)
  }), core.jsx(Table, _extends({}, rest, {
    state: state
  }, tableAttributes(state), {
    css: tableStyles(state)
  }), children)));
};

function ownKeys$1(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

Table$1.propTypes = {
  striped: PropTypes.bool,
  bordered: PropTypes.bool,
  overrides: PropTypes.shape({
    Table: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Caption: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Tbody: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Td: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Tfoot: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Th: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Thead: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    }),
    Tr: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
}, Table$1.defaultProps = {
  bordered: !1,
  striped: !1
};

var Caption = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("caption", rest);
}, captionStyles = function() {
  return _objectSpread$1({
    fontSize: "1.125rem",
    textAlign: "left",
    marginBottom: "0.75rem"
  }, core.useBrand().TYPE.bodyFont[300]);
}, captionAttributes = function() {
  return null;
}, defaultCaption = {
  component: Caption,
  styles: captionStyles,
  attributes: captionAttributes
};

function ownKeys$2(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$2(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$2(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Caption$1 = function(_ref) {
  var children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext(), defaultOverrides = {
    Caption: defaultCaption
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$2({
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$C = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Caption, Caption = _overrideReconciler$C.component, CaptionStyles = _overrideReconciler$C.styles, CaptionAttributes = _overrideReconciler$C.attributes;
  return core.jsx(Caption, _extends({}, rest, {
    state: state
  }, CaptionAttributes(state), {
    css: CaptionStyles(state)
  }), children);
};

function ownKeys$3(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$3(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$3(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$3(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

Caption$1.propTypes = {
  overrides: PropTypes.shape({
    Caption: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
};

var Thead = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("thead", rest);
}, theadStyles = function(_, _ref2) {
  var bordered = _ref2.bordered, _useBrand = core.useBrand(), COLORS = _useBrand.COLORS, TYPE = _useBrand.TYPE;
  return {
    "th, td": {
      borderTop: !bordered && 0
    },
    th: _objectSpread$3({
      verticalAlign: "bottom",
      borderBottom: "".concat(bordered ? "2px" : "3px", " solid ").concat(COLORS.hero),
      color: COLORS.text
    }, TYPE.bodyFont[700])
  };
}, theadAttributes = function() {
  return null;
}, defaultThead = {
  component: Thead,
  styles: theadStyles,
  attributes: theadAttributes
};

function ownKeys$4(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$4(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$4(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$4(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Thead$1 = function(_ref) {
  var bordered = _ref.bordered, children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "bordered", "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Thead: defaultThead
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$4({
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$T = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Thead, Thead = _overrideReconciler$T.component, theadStyles = _overrideReconciler$T.styles, theadAttributes = _overrideReconciler$T.attributes;
  return core.jsx(Thead, _extends({}, rest, {
    state: state
  }, theadAttributes(state), {
    css: theadStyles(state)
  }), children);
};

Thead$1.propTypes = {
  bordered: PropTypes.bool,
  overrides: PropTypes.shape({
    Thead: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
};

var Tr = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("tr", rest);
}, trStyles = function(_, _ref2) {
  var striped = _ref2.striped, highlighted = _ref2.highlighted, COLORS = core.useBrand().COLORS;
  return {
    transition: !striped && "background 0.2s ease",
    borderLeft: "boolean" == typeof highlighted && highlighted ? "6px solid ".concat(COLORS.primary) : 0,
    borderBottom: "boolean" == typeof highlighted && highlighted ? "3px solid ".concat(COLORS.primary) : "1px solid ".concat(COLORS.border),
    "tbody > &:hover": {
      backgroundColor: !striped && COLORS.background
    }
  };
}, trAttributes = function() {
  return null;
}, defaultTr = {
  component: Tr,
  styles: trStyles,
  attributes: trAttributes
};

function ownKeys$5(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$5(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$5(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$5(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var generateHighlightMap = function(highlighted, tdCount) {
  var map = Array(tdCount).fill(!1);
  return highlighted.forEach((function(highlight) {
    "number" == typeof highlight ? map[highlight] = !0 : Array.isArray(highlight) && map.fill(!0, highlight[0], highlight[1] + 1);
  })), map;
}, Tr$1 = function(_ref) {
  var striped = _ref.striped, highlighted = _ref.highlighted, children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "striped", "highlighted", "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext();
  striped = context && context.striped || striped;
  var highlightedChildren, defaultOverrides = {
    Tr: defaultTr
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$5({
    striped: striped,
    highlighted: highlighted,
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$T = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Tr, Tr = _overrideReconciler$T.component, trStyles = _overrideReconciler$T.styles, trAttributes = _overrideReconciler$T.attributes;
  if (Array.isArray(highlighted)) {
    var highlightMap = generateHighlightMap(highlighted, react.Children.count(children));
    highlightedChildren = react.Children.map(children, (function(child, index) {
      return !0 === highlightMap[index] ? 0 === index || !1 === highlightMap[index - 1] ? react.cloneElement(child, {
        highlightStart: !0,
        highlighted: !0
      }) : react.cloneElement(child, {
        highlighted: !0
      }) : child;
    }));
  }
  return core.jsx(Tr, _extends({}, rest, {
    state: state
  }, trAttributes(state), {
    css: trStyles(state)
  }), highlightedChildren || children);
};

Tr$1.propTypes = {
  highlighted: PropTypes.oneOfType([ PropTypes.bool, PropTypes.array ]),
  overrides: PropTypes.shape({
    Tr: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
}, Tr$1.defaultProps = {
  highlighted: !1
};

var Th = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("th", rest);
}, thStyles = function(_, _ref2) {
  var bordered = _ref2.bordered, COLORS = core.useBrand().COLORS;
  return {
    padding: "0.75rem",
    verticalAlign: "top",
    border: "1px solid ".concat(COLORS.border),
    borderLeft: !bordered && 0,
    borderRight: !bordered && 0,
    textAlign: "left"
  };
}, thAttributes = function() {
  return null;
}, defaultTh = {
  component: Th,
  styles: thStyles,
  attributes: thAttributes
};

function ownKeys$6(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$6(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$6(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$6(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Th$1 = function(_ref) {
  var bordered = _ref.bordered, children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "bordered", "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Th: defaultTh
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$6({
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$T = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Th, Th = _overrideReconciler$T.component, thStyles = _overrideReconciler$T.styles, thAttributes = _overrideReconciler$T.attributes;
  return core.jsx(Th, _extends({}, rest, {
    state: state
  }, thAttributes(state), {
    css: thStyles(state)
  }), children);
};

Th$1.propTypes = {
  bordered: PropTypes.bool,
  overrides: PropTypes.shape({
    Th: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
};

var Tbody = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("tbody", rest);
}, tbodyStyles = function() {
  return {};
}, tbodyAttributes = function() {
  return null;
}, defaultTBody = {
  component: Tbody,
  styles: tbodyStyles,
  attributes: tbodyAttributes
};

function ownKeys$7(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$7(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$7(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$7(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Tbody$1 = function(_ref) {
  var children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext(), defaultOverrides = {
    Tbody: defaultTBody
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$7({
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$T = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Tbody, Tbody = _overrideReconciler$T.component, tbodyStyles = _overrideReconciler$T.styles, tbodyAttributes = _overrideReconciler$T.attributes;
  return core.jsx(Tbody, _extends({}, rest, {
    state: state
  }, tbodyAttributes(state), {
    css: tbodyStyles(state)
  }), children);
};

function ownKeys$8(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$8(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$8(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$8(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

Tbody$1.propTypes = {
  overrides: PropTypes.shape({
    Tbody: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
};

var Td = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("td", rest);
}, tdStyles = function(_, _ref2) {
  var highlighted = _ref2.highlighted, highlightStart = _ref2.highlightStart, bordered = _ref2.bordered, _useBrand = core.useBrand(), COLORS = _useBrand.COLORS, TYPE = _useBrand.TYPE;
  return {
    padding: "0.75rem",
    verticalAlign: "top",
    border: bordered && "1px solid ".concat(COLORS.border),
    borderLeft: highlightStart && "6px solid ".concat(COLORS.primary),
    borderBottom: highlighted && "3px solid ".concat(COLORS.primary),
    "&[scope=row]": _objectSpread$8({}, TYPE.bodyFont[700])
  };
}, tdAttributes = function() {
  return null;
}, defaultTd = {
  component: Td,
  styles: tdStyles,
  attributes: tdAttributes
};

function ownKeys$9(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$9(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$9(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$9(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Td$1 = function(_ref) {
  var highlighted = _ref.highlighted, highlightStart = _ref.highlightStart, bordered = _ref.bordered, children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "highlighted", "highlightStart", "bordered", "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Td: defaultTd
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$9({
    highlighted: highlighted,
    highlightStart: highlightStart,
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$T = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Td, Td = _overrideReconciler$T.component, tdStyles = _overrideReconciler$T.styles, tdAttributes = _overrideReconciler$T.attributes;
  return core.jsx(Td, _extends({}, rest, {
    state: state
  }, tdAttributes(state), {
    css: tdStyles(state)
  }), children);
};

Td$1.propTypes = {
  highlighted: PropTypes.bool,
  highlightStart: PropTypes.bool,
  bordered: PropTypes.bool,
  overrides: PropTypes.shape({
    Td: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
}, Td$1.defaultProps = {
  highlighted: !1,
  highlightStart: !1
};

var TFoot = function(_ref) {
  _ref.state;
  var rest = _objectWithoutProperties(_ref, [ "state" ]);
  return core.jsx("tfoot", rest);
}, tfootStyles = function(_, _ref2) {
  var bordered = _ref2.bordered;
  return {
    color: core.useBrand().COLORS.muted,
    "th, tr, td": {
      borderBottom: !bordered && 0
    }
  };
}, tfootAttributes = function() {
  return null;
}, defaultTfoot = {
  component: TFoot,
  styles: tfootStyles,
  attributes: tfootAttributes
};

function ownKeys$a(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread$a(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$a(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$a(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Tfoot = function(_ref) {
  var bordered = _ref.bordered, children = _ref.children, overrides = _ref.overrides, rest = _objectWithoutProperties(_ref, [ "bordered", "children", "overrides" ]), _useBrand = core.useBrand(), tokenOverrides = _useBrand.OVERRIDES[pkg.name], brandOverrides = _useBrand[pkg.name], context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Tfoot: defaultTfoot
  }, componentOverrides = overrides || context.state.overrides, state = _objectSpread$a({
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest), _overrideReconciler$T = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides).Tfoot, Tfoot = _overrideReconciler$T.component, tfootStyles = _overrideReconciler$T.styles, tfootAttributes = _overrideReconciler$T.attributes;
  return core.jsx(Tfoot, _extends({}, rest, {
    state: state
  }, tfootAttributes(state), {
    css: tfootStyles(state)
  }), children);
};

Tfoot.propTypes = {
  bordered: PropTypes.bool,
  overrides: PropTypes.shape({
    Tfoot: PropTypes.shape({
      styles: PropTypes.func,
      component: PropTypes.elementType,
      attributes: PropTypes.func
    })
  })
}, exports.Caption = Caption$1, exports.Table = Table$1, exports.Tbody = Tbody$1, 
exports.Td = Td$1, exports.Tfoot = Tfoot, exports.Th = Th$1, exports.Thead = Thead$1, 
exports.Tr = Tr$1;
